import java.net.*;
import java.io.*;
import java.util.*;

public class bridge extends Thread {
	private static int QDEPTH=2;

	private int				inPort=123;
	private InetAddress		inAddr=null;
	private int				outPort=123;
	private InetAddress		outAddr=null;
	private ServerSocket	server=null;
	private boolean			active=false;

	public bridge(InetAddress fromAddr,int fromPort,InetAddress toAddr, int toPort) throws IOException {
		inPort = fromPort;
		inAddr = fromAddr;
		outPort = toPort;
		outAddr = toAddr;
		server = new ServerSocket(inPort,bridge.QDEPTH,inAddr);
		active=true;
	}

	public void run() {
		while (active) {
			try {
				new duplex(server.accept(),outAddr,outPort);
			}
			catch (IOException e) {
				System.err.println(e);
			}
		}

		try {
			server.close();
		}
		catch (IOException e) {}
	}

	public static void main(String[] args) {
		InetAddress here=null;
		InetAddress there=null;
		int herePort=0;
		int therePort=0;
		bridge app=null;

		if (args.length == 4) {
			try {
				here = InetAddress.getByName(args[0]);
				herePort = Integer.parseInt(args[1]);
			}
			catch (NumberFormatException e) {
				System.err.println("invalid port# ["+args[1]+"]");
				System.err.println(e);
				System.exit(-1);
			}
			catch (UnknownHostException e) {
				System.err.println("host not found ["+args[0]+"]");
				System.err.println(e);
				System.exit(-1);
			}


			try {
				there = InetAddress.getByName(args[2]);
				therePort = Integer.parseInt(args[3]);
			}
			catch (NumberFormatException e) {
				System.err.println("invalid port# ["+args[3]+"]");
				System.err.println(e);
				System.exit(-1);
			}
			catch (UnknownHostException e) {
				System.err.println("host not found ["+args[2]+"]");
				System.err.println(e);
				System.exit(-1);
			}

			try {
				app = new bridge(here,herePort,there,therePort);
				app.start();
			}
			catch (IOException e) {
				System.err.println("bind failed");
				System.err.println(e);
				System.exit(-1);
			}

		}
		else {
			System.err.println("bridge bindIpAddress bindPort hostAddress hostPort");
		}
	}
}
